sdkp = LibStub("AceAddon-3.0"):NewAddon("sdkp", "AceConsole-3.0", "AceEvent-3.0", "AceComm-3.0", "AceSerializer-3.0", "AceTimer-3.0", "AceHook-3.0");

local optionsFrame
-- Some globals used in sdkpdata
sdkp.COLOR_UNKNOWN_CLASS = { ["r"]=0.5, ["g"]=0.5, ["b"]=0.5, ["a"]=1.0,};
sdkp.COLOR_LOWPRIORITY = { ["r"]=0.75, ["g"]=0.0, ["b"]=0.0, ["a"]=1.0,};
sdkp.COLOR_MEDIUMPRIORITY = { ["r"]=1.0, ["g"]=1.0, ["b"]=0.0, ["a"]=1.0,};
sdkp.COLOR_HIGHPRIORITY = { ["r"]=0.0, ["g"]=1.0, ["b"]=0.0, ["a"]=1.0,};


sdkp.FUNC_COLOR_BRACKET = function(data, cols, realrow, column, table, ...)
	local rowdata = data[realrow];
	--local celldata = rowdata.cols[3];	-- Use to be cols[3] for TDA, changed to [1] for player name
	
	local celldata = rowdata.cols[1].value;
	local currentbid = sdkp.db.profile.bids[string.lower(celldata)];
	
	local maxbid = 0;
	for key,value in pairs(sdkp.db.profile.bids) do 
		if value then
			if maxbid < value then
				maxbid = value;
			end
		end
		--sdkp:Debug("key: " .. key .. " value: " .. value);
	end
	--sdkp:Debug("Max bid found was: " .. maxbid);
	
	if not currentbid then
		return sdkp.COLOR_LOWPRIORITY;
	end
	
	local dkp = rowdata.cols[7].value;
		if type(dkp) == "function" then 
			--data, cols, realrow, column, table
			dkp = dkp(unpack({sdkp.BIDSCROLLFRAME.data, sdkp.BIDSCROLLFRAME.cols, SDKPPLAYER[rowdata.cols[1].value:lower()], 7, sdkp.BIDSCROLLFRAME}));
		end
	
	if sdkp:IsShroudDkp() and dkp < sdkp.db.profile.floorShroud then
		return sdkp.COLOR_LOWPRIORITY;		-- If player is below DKP floor, color as red
	elseif dkp < sdkp.db.profile.floorZeroSum then
		return sdkp.COLOR_LOWPRIORITY;		-- If player is below DKP floor, color as red
	end
	
	--sdkp:Debug("Max: " .. maxbid .. " Current: " .. currentbid .. " Floor: " .. sdkp.db.profile.floorShroud);
	if currentbid == maxbid then
		return sdkp.COLOR_HIGHPRIORITY;		-- Highest bid wins, highlight winner(s) in green
	elseif currentbid >= 1 then
		return sdkp.COLOR_MEDIUMPRIORITY;	-- Non winning bids shown in yellow to determine winner price
	else
		return sdkp.COLOR_LOWPRIORITY;
	end	
	--[[
	tdatt = celldata.value;
	if tdatt >= 80.0 then
		return sdkp.COLOR_HIGHPRIORITY;    -- >= 70% 30 day
	elseif tdatt >= 60 then 
		return sdkp.COLOR_MEDIUMPRIORITY;  --  < 70% 30 day
	else
		return sdkp.COLOR_LOWPRIORITY;
	end ]]--
end

sdkp.FUNC_DKP_TOTAL = function(data, cols, realrow, column, table, ...)
	local rowdata = data[realrow];
			
	local dkp = rowdata.earned + rowdata.adjustments;
	local spent = rowdata.spent;
	if sdkp.db.profile.loot then 
		for _, lootdata in pairs(sdkp.db.profile.loot) do 
			-- if looter is player or player's main
			if lootdata["player"]:lower() == rowdata.cols[1].value:lower() or lootdata["player"]:lower() ==  rowdata.cols[2].value:lower() then 
				sdkp:Debug("Found purchase by", lootdata["player"], "for", lootdata["price"], tonumber(lootdata["price"]) or 0);
				spent = spent + (tonumber(lootdata["price"]) or 0); -- dkp - price of loot won.
			end
		end
	end
	
	if sdkp:IsRelationalDkp() then 
		spent = spent + sdkp:GetInitialGearValue();
		if spent == 0 then 
			spent = 1;
		end
		dkp = dkp / spent;
	else
		dkp = dkp - spent;
	end
	return tonumber(string.format("%.3f", dkp));
end

sdkp.FUNC_PLAYER_BID = function(data, cols, realrow, column, table, ...)
	local rowdata = data[realrow];
	local celldata = rowdata.cols[1];
	
	-- local bid = sdkp.db.profile.bids ? sdkp.db.profile.bids[namecol.value:lower()] : "";
	local bid = sdkp.db.profile.bids and sdkp.db.profile.bids[celldata.value:lower()] or "";
	return bid or "";
end

function sdkp:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("SDKPDB", SDKP_DEFAULTS, "Default")
    LibStub("AceConfig-3.0"):RegisterOptionsTable("sdkp", SDKP_OPTIONS);
    self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("sdkp", "sdkp");
    self:RegisterChatCommand("sdkp", "ChatCommand");
    if SDKP_DATA_INIT then
    	SDKP_DATA_INIT();
    	if not sdkp.db.profile.currentsystem then 
    		for system in pairs(SDKPDATA) do
    			sdkp.db.profile.currentsystem = system;
    			break;
    		end
   		end
    else
    	self:Print("Could not locate dkp data.  Please download the sdkpdata.lua file and place it in the Interface\\AddOns\\sdkp folder.");
    end
    --OrigChatFrameOnEvent = ChatFrame_OnEvent;
    --ChatFrame_OnEvent = HookChatFrameOnEvent;
    self.BIDDING = false;
    self:SecureHook("SetItemRef");
    self:RawHook("ChatFrame_OnEvent", true); -- whisper commands
    self.bb = LibStub("LibBabble-Boss-3.0"):GetReverseLookupTable();
    SDKP_RAID_ZONE["Scarlet Monastery"] = self.db.profile.debug; -- easy to test on sm bosses, close to zone.
    
    for i, snapshot in ipairs(self.db.profile.snapshots) do 
    	self:AddRaidFilter(snapshot.name, self:GetLastFullSnapshot(i).playertable);
    end
    
    self:ShowBids();
    self.newui:Hide();

	-- initialize ui values
	if self.db and self.db.profile.currentfilter then 
    	self.newui.filtercontrol:Fire("OnValueChanged", self.db.profile.currentfilter);
    end
    
    -- initialize variables 
    self.penaltybox = {};
end

function sdkp:OnEnable()
    self:Print("Enabled.");
    self:RegisterEvent("CHAT_MSG_LOOT");
	self:RegisterEvent("PLAYER_REGEN_ENABLED");
	for key in pairs(SDKP_BID_CHANNEL) do 
		self:RegisterEvent(key);
	end
	self:RegisterEvent("CHAT_MSG_RAID_LEADER");
	self:RegisterEvent("LOOT_OPENED");
	self:RegisterEvent("ZONE_CHANGED_NEW_AREA");
	self:RegisterComm(self.name, "OnCommReceive");
	
	self:RegisterMessage("SDKP_LOOT_ASSIGNED");
	
	if self:IsTrackLoot() then
		self:RegisterEvent("READY_CHECK");
	end	
end
function sdkp:OnDisable()
    self:Print("Disabled.");
end

function sdkp:GetDkpForItem(item)
	local ilvl, dkp = 0, 0;
	if ilvlDKP then 
		ilvl, dkp = ilvlDKP(item);
	else
		self:Print("You should install ItemLevelDkp...")
	end
	return dkp;
end

function sdkp:SendWhisper(who, what)
	self:SendChatMessage(what, "WHISPER", nil, who);	
end
function sdkp:SendOfficer(what)
	self:SendChatMessage(what, "OFFICER");	
end
function sdkp:SendRaid(what)
	self:SendChatMessage(what, "RAID");	
end
function sdkp:SendRaidWarning(what)
	self:SendChatMessage(what, "RAID_WARNING");	
end
function sdkp:SendGuild(what)
	self:SendChatMessage(what, "GUILD");	
end
function sdkp:SendChatMessage(what, where, ...)
	SendChatMessage(self.name .. ": " .. what, where, ...);	
end

function sdkp:GetAltInfo(player)
	local playerindex = SDKPPLAYER[player:lower()];
	if not playerindex then
		local i, numGuildMembers = 1, GetNumGuildMembers(true);
		for i = 1, numGuildMembers do 
			local name, _, _, _, _, _, _, officernote, _, _ = GetGuildRosterInfo(i);
			if name:lower() == player:lower() then
				local _, _, main = string.find(officernote, "^Main:%s+([^%s]+)");
				if main then 
					sdkp:Debug("GetAltInfo:", name, officernote, main);
					sdkp:Debug("GetAltInfo (altmatch):", player, "=>", main);
					return main;
				end
			end
		end
	else
		local pdata = SDKPDATA[sdkp.db.profile.currentsystem][playerindex];
		if pdata.cols[2].value ~= "" then
			sdkp:Debug("GetAltInfo (doigethere?):", player, "=>", pdata.cols[2].value);
			return pdata.cols[2].value;
		elseif pdata.cols[1].value:lower() == player:lower() then
			sdkp:Debug("GetAltInfo (mainmatch):", player, "=>", pdata.cols[1].value);
			return pdata.cols[1].value;			
		end
	end
	sdkp:Debug("GetAltInfo (failed):", player, "=>", player);
	return player;
end

function sdkp:getPlayerData(player)
	local playerindex = SDKPPLAYER[player:lower()];
	local pdata = nil;
	if playerindex then 
		pdata = SDKPDATA[sdkp.db.profile.currentsystem][playerindex];
	else
		local main = self:GetAltInfo(player);
		playerindex = SDKPPLAYER[main:lower()];
		if playerindex then 
			pdata = SDKPDATA[sdkp.db.profile.currentsystem][SDKPPLAYER[main:lower()]];
		end
	end
	return pdata;
end

function sdkp:getPlayerRank(player)
	local i, numGuildMembers = 1, GetNumGuildMembers(true);
	for i = 1, numGuildMembers do 
		local name, rankString, rankIndex, _, _, _, _, _, _, _ = GetGuildRosterInfo(i);
		if name:lower() == player:lower() then
			sdkp:Debug("GetRankInfo:", name, rankString, rankIndex);
			return rankString, rankIndex;
		end
	end
end

function sdkp:Debug(...)
	if self:IsDebug() then 
		self:Print("Debug: ", ...)
	end
end

-- Hooks
function sdkp:SetItemRef(link, text, button)
	local biditem = getglobal("sdkpeditbox");
	if biditem and not sdkp.BIDDING and link:find("^item:") then
		biditem:SetText(text);
	end
end

function sdkp:ChatFrame_OnEvent(context, event, msg, ...)
	-- this hook is used to hide unwanted messages from sight.
	if event == "CHAT_MSG_WHISPER_INFORM" and msg:find("^" .. sdkp.name) then
		-- responding to a whisper command.
		sdkp:Debug("event", event, "msg", msg, ...);
	elseif event == "CHAT_MSG_WHISPER" and 
		(msg:find("^!help") or msg:find("^!here") or msg:find("^!dkp") 
		or msg:find("^!attendance") or msg:find("^!att")
		or msg:find("^!waitlist") or msg:find("^!wl")) then
		-- hide incoming whisper commands
		sdkp:Debug("event", event, "msg", msg, ...);
	else
		-- call original handler
		self.hooks["ChatFrame_OnEvent"](context, event, msg, ...);	
	end
end

function sdkp:RefreshScrollTables()
	if self.BIDSCROLLFRAME then
    	self.BIDSCROLLFRAME:SortData();
	end
	if self.LOOTDETAILFRAME then
    	self.LOOTDETAILFRAME:SortData();
	end	
	
	if self.newui ~= nil then 
		self.newui.filtercontrol:SetList(SDKP_FILTERS_LIST);
	end
end

function sdkp:AddRaidFilter(sRaidNote, tPlayerTable)
	local sLabel = "   " .. sRaidNote;
	if sLabel ~= SDKP_FILTERS_LIST[#SDKP_FILTERS_LIST] then 
		table.insert(SDKP_FILTERS_LIST, sLabel);
		SDKP_FILTERS[sLabel] = function(self, row)
			return tPlayerTable[row.cols[1].value];	
		end;
		self:RefreshScrollTables();
	end
end

function sdkp:GetCurrentBid(player) 
	player = player:lower();
	local bid = self.db.profile.bids[player];
	if bid then 
		bid = tonumber(bid);
		if not bid then 
			bid = 1;
			self.db.profile.bids[player] = bid;
		end
	end
	return bid;
end

function sdkp:GetLastFullSnapshot(start)
	local snapshots = self.db.profile.snapshots;
	local index = start or #snapshots;
	local fullsnap = snapshots[index];
	while not fullsnap.playertable and index >= 1 do
		index = index - 1; 
		fullsnap = snapshots[index];
	end
	return fullsnap;
end

function sdkp:GetNextFullRaidIndex(snapshots, fromindex)
	local index = fromindex;
	while index <= #snapshots do 
		if snapshots[index].playertable then 
			return index;
		end
		index = index + 1;
	end
end

-- Update presence list
function sdkp:UpdateRaidPresence(info)
	local nRaidMembers = GetNumRaidMembers();
	local presence = self.db.profile.raidPresence;
	
	for raidIndex = 1, nRaidMembers do
		local raidMember = GetRaidRosterInfo(raidIndex);
		local main = self:GetAltInfo(raidMember);
		if main then 
			raidMember = main;	
		end
		
		if presence[raidMember] then
			presence[raidMember] = presence[raidMember] + 1;
		else
			presence[raidMember] = 1;
		end
		
	end
end

-- Return a list of raids on presence list making 30% of checks
function sdkp:GetPresenceTable()
	local presence = self.db.profile.raidPresence;
	local threshhold = presence[UnitName("player")] * 3/10;
	local presenceList = {};
	
	sdkp:Debug("Threshhold: "..threshhold);
	for player, number in pairs(presence) do
		sdkp:Debug("Player: "..player.." Number: "..number);
		if number >= threshhold then
			table.insert(presenceList, player)
		end
	end 
	
	return presenceList;	
end